Index: engine/jitc_pinvoke.c
===================================================================
RCS file: /sources/dotgnu-pnet/./pnet/engine/jitc_pinvoke.c,v
retrieving revision 1.3
diff -c -r1.3 jitc_pinvoke.c
*** engine/jitc_pinvoke.c	28 Jul 2006 17:41:54 -0000	1.3
--- engine/jitc_pinvoke.c	16 Sep 2006 13:26:34 -0000
***************
*** 1353,1412 ****
  	}			
      }
      else if(ILType_IsValueType(type))
!     {	
  	    if(addressKind==MARSHAL_FIRST_LEVEL_VALUE)
  	    {
! 		    MarshalByRefStruct(function, jit_insn_address_of(function, in), type, jit_insn_address_of(function, in), 0, MARSHAL_ITEM_OF_STRUCTURE);
  		    return;
  	    }
! 	    temp = jit_insn_load_relative(function, in, offset, _IL_JIT_TYPE_VPTR);
! 	    MarshalByRefStruct(function, temp, type, temp, offset, MARSHAL_ITEM_OF_STRUCTURE);
  	    return;
      }
      else if(ILTypeIsStringClass(type))
!     {	   
  	    args[0] = _ILJitFunctionGetThread(function);
  	    if(addressKind==MARSHAL_FIRST_LEVEL_VALUE) args[1] = in;
  	    else args[1] = jit_insn_load_relative(function, in, offset, _IL_JIT_TYPE_VPTR);
  	    switch(marshalType)
  	    {
  			case IL_META_MARSHAL_ANSI_STRING:
  			{
! 				    jit_insn_store(function, temp, jit_insn_call_native(function,
! 						    "ILStringCreate",
! 						    ILStringCreate,
! 						    _ILJitSignature_ILStringCreate,
! 						    args, 2, JIT_CALL_NOTHROW));
  			}
  			break;
  			case IL_META_MARSHAL_UTF8_STRING:
  			{
! 				    jit_insn_store(function, temp, jit_insn_call_native(function,
! 						    "ILStringCreateUTF8",
! 						    ILStringCreateUTF8,
! 						    _ILJitSignature_ILStringCreateUTF8,
! 						    args, 2, JIT_CALL_NOTHROW));
  			}
  			break;
  			case IL_META_MARSHAL_UTF16_STRING:
  			{
! 				    jit_insn_store(function, temp, jit_insn_call_native(function,
! 						    "ILStringWCreate",
! 						    ILStringWCreate,
! 						    _ILJitSignature_ILStringWCreate,
! 						    args, 2, JIT_CALL_NOTHROW));
  			}
  			break;
  	    }
  	    if(addressKind==MARSHAL_ITEM_OF_STRUCTURE || addressKind==MARSHAL_ITEM_OF_ARRAY)
! 		    jit_insn_store_relative(function, in, offset, temp);
! 	    return;
!     }
!     else if(ILTypeIsDelegate(type))
!     {
  	    return;
      }
!     else if(ILType_IsClass(type))
      {
  	    return;
      }
--- 1623,1689 ----
  	}			
      }
      else if(ILType_IsValueType(type))
!     {
  	    if(addressKind==MARSHAL_FIRST_LEVEL_VALUE)
  	    {
! 		    MarshalByRefStruct(function, jit_insn_address_of(function, in), type, marshalType, outAddressValue, 0, MARSHAL_ITEM_OF_STRUCTURE);
  		    return;
  	    }
! 	    MarshalByRefStruct(function, in, type, marshalType, outAddressValue, offset, MARSHAL_ITEM_OF_STRUCTURE);
  	    return;
      }
      else if(ILTypeIsStringClass(type))
!     {
  	    args[0] = _ILJitFunctionGetThread(function);
  	    if(addressKind==MARSHAL_FIRST_LEVEL_VALUE) args[1] = in;
  	    else args[1] = jit_insn_load_relative(function, in, offset, _IL_JIT_TYPE_VPTR);
+ 	    char *customName;
+ 	    int customNameLen;
+ 	    char *customCookie;
+ 	    int customCookieLen;
+ 	    ILMethod *method = (ILMethod *)jit_function_get_meta(function, IL_JIT_META_METHOD);
+ 	    marshalType = ILPInvokeGetMarshalType
+ 			    (0, method, 0, &customName, &customNameLen, &customCookie, &customCookieLen, type);
  	    switch(marshalType)
  	    {
  			case IL_META_MARSHAL_ANSI_STRING:
  			{
! 				temp = jit_insn_call_native(function,
! 							    "ILStringCreate",
! 							    ILStringCreate,
! 							    _ILJitSignature_ILStringCreate,
! 							    args, 2, JIT_CALL_NOTHROW);
  			}
  			break;
  			case IL_META_MARSHAL_UTF8_STRING:
  			{
! 				temp = jit_insn_call_native(function,
! 							    "ILStringCreateUTF8",
! 							    ILStringCreateUTF8,
! 							    _ILJitSignature_ILStringCreateUTF8,
! 							    args, 2, JIT_CALL_NOTHROW);
  			}
  			break;
  			case IL_META_MARSHAL_UTF16_STRING:
  			{
! 				temp = jit_insn_call_native(function,
! 							    "ILStringWCreate",
! 							    ILStringWCreate,
! 							    _ILJitSignature_ILStringWCreate,
! 							    args, 2, JIT_CALL_NOTHROW);
! 			}
! 			break;
! 			default:
! 			{
! 				temp = args[1];
  			}
  			break;
  	    }
  	    if(addressKind==MARSHAL_ITEM_OF_STRUCTURE || addressKind==MARSHAL_ITEM_OF_ARRAY)
! 		    jit_insn_store_relative(function, outAddressValue, offset, temp);
  	    return;
      }
!     else if(ILTypeIsDelegateSubClass(type))
      {
  	    return;
      }
***************
*** 1416,1426 ****
  	    {
  		    case IL_TYPE_COMPLEX_PTR:
  		    {
- 			    if(addressKind==MARSHAL_FIRST_LEVEL_VALUE)return;
- 			    temp = jit_insn_load_relative(function, in, offset, _IL_JIT_TYPE_VPTR);
- 			    jit_insn_store_relative(function, outAddressValue, offset, temp);
  			    return;
! 		    };
  		    break;
  		    case IL_TYPE_COMPLEX_BYREF:
  		    {
--- 1693,1700 ----
  	    {
  		    case IL_TYPE_COMPLEX_PTR:
  		    {
  			    return;
! 		    }
  		    break;
  		    case IL_TYPE_COMPLEX_BYREF:
  		    {
***************
*** 1430,1448 ****
  			    }
  			    else jit_insn_store(function, srcArray, in);
  			    ILType *elemType = ILType_Ref(type);
  			    if(NeedMarshalValue(elemType))
  			    {
  				    if(addressKind==MARSHAL_ITEM_OF_STRUCTURE || addressKind==MARSHAL_ITEM_OF_ARRAY)
  				    {
  				    
  					    MarshalByRefValue(function, jit_insn_dup(function, srcArray),
! 										    elemType, current,
  										    MARSHAL_ITEM_OF_STRUCTURE,
  										    0,
  										    jit_insn_load_relative(function, outAddressValue, offset, _IL_JIT_TYPE_VPTR));
  				    }
  				    else MarshalByRefValue(function, jit_insn_dup(function, srcArray),
! 										    elemType, current,
  										    MARSHAL_ITEM_OF_STRUCTURE,
  										    0,
  										    srcArray);
--- 1704,1723 ----
  			    }
  			    else jit_insn_store(function, srcArray, in);
  			    ILType *elemType = ILType_Ref(type);
+ 			    elemType = ILTypeGetEnumType(elemType);
  			    if(NeedMarshalValue(elemType))
  			    {
  				    if(addressKind==MARSHAL_ITEM_OF_STRUCTURE || addressKind==MARSHAL_ITEM_OF_ARRAY)
  				    {
  				    
  					    MarshalByRefValue(function, jit_insn_dup(function, srcArray),
! 										    elemType, marshalType,
  										    MARSHAL_ITEM_OF_STRUCTURE,
  										    0,
  										    jit_insn_load_relative(function, outAddressValue, offset, _IL_JIT_TYPE_VPTR));
  				    }
  				    else MarshalByRefValue(function, jit_insn_dup(function, srcArray),
! 										    elemType, marshalType,
  										    MARSHAL_ITEM_OF_STRUCTURE,
  										    0,
  										    srcArray);
***************
*** 1457,1480 ****
  	    {
  			    srcArray = in;
  			    if(addressKind==MARSHAL_ITEM_OF_STRUCTURE || addressKind==MARSHAL_ITEM_OF_ARRAY)
  				    srcArray = jit_insn_load_relative(function, srcArray, offset, _IL_JIT_TYPE_VPTR);
  			    elemType = ILType_ElemType(type);
! 
  			    if(!NeedMarshalValue(elemType))
  			    {
  				    return;
  			    }
- 
  			    // The size of a simple array can be known only on run-time.
  			    arraySize = jit_insn_load_relative(function, outAddressValue, 0, _IL_JIT_TYPE_UINT32);
  			    thread = ILExecThreadCurrent();
  			    srcElemSize = jit_value_create_nint_constant(function,
! 				    						_IL_JIT_TYPE_INT32,
! 										(jit_nint)(ILSizeOfType(thread, elemType)));
  			    newElemSize = jit_value_create_nint_constant(function,
  										_IL_JIT_TYPE_INT32,
  									    	(jit_nint)(ILSizeOfType(thread, elemType)));
- 
  			    newArray = jit_insn_add_relative(function, outAddressValue, (jit_nint)(sizeof(ILUInt32)));
  			    jit_insn_branch_if(function,
  						jit_insn_eq(function, arraySize,
--- 1732,1759 ----
  	    {
  			    srcArray = in;
  			    if(addressKind==MARSHAL_ITEM_OF_STRUCTURE || addressKind==MARSHAL_ITEM_OF_ARRAY)
+ 			    {
  				    srcArray = jit_insn_load_relative(function, srcArray, offset, _IL_JIT_TYPE_VPTR);
+ 			    }
+ 			    jit_insn_branch_if_not(function, jit_insn_to_bool(function, srcArray),
+ 							    &endLoop);
+ 			    jit_insn_branch_if_not(function, jit_insn_to_bool(function, outAddressValue),
+ 							    &endLoop);
  			    elemType = ILType_ElemType(type);
! 			    elemType = ILTypeGetEnumType(elemType);
  			    if(!NeedMarshalValue(elemType))
  			    {
  				    return;
  			    }
  			    // The size of a simple array can be known only on run-time.
  			    arraySize = jit_insn_load_relative(function, outAddressValue, 0, _IL_JIT_TYPE_UINT32);
  			    thread = ILExecThreadCurrent();
  			    srcElemSize = jit_value_create_nint_constant(function,
! 					    					_IL_JIT_TYPE_INT32,
! 										(jit_nint)(ILSizeOfType(thread, elemType)));			    
  			    newElemSize = jit_value_create_nint_constant(function,
  										_IL_JIT_TYPE_INT32,
  									    	(jit_nint)(ILSizeOfType(thread, elemType)));
  			    newArray = jit_insn_add_relative(function, outAddressValue, (jit_nint)(sizeof(ILUInt32)));
  			    jit_insn_branch_if(function,
  						jit_insn_eq(function, arraySize,
***************
*** 1483,1496 ****
  										&endLoop);
  			    srcElemAddress = jit_insn_dup(function, srcArray);
  			    newElemAddress = jit_insn_dup(function, newArray);
! 			    counter = arraySize;
  			    jit_insn_label(function, &startLoop);
  			    jit_insn_store(function, counter, jit_insn_sub(function, counter,
  		    									jit_value_create_nint_constant(function,
  											_IL_JIT_TYPE_INT32,
  											1)));
  			    MarshalByRefValue(function, srcElemAddress,
! 								elemType, current,
  								MARSHAL_ITEM_OF_ARRAY,
  								0,
  								newElemAddress);
--- 1762,1775 ----
  										&endLoop);
  			    srcElemAddress = jit_insn_dup(function, srcArray);
  			    newElemAddress = jit_insn_dup(function, newArray);
! 			    counter = jit_insn_dup(function, arraySize);
  			    jit_insn_label(function, &startLoop);
  			    jit_insn_store(function, counter, jit_insn_sub(function, counter,
  		    									jit_value_create_nint_constant(function,
  											_IL_JIT_TYPE_INT32,
  											1)));
  			    MarshalByRefValue(function, srcElemAddress,
! 								elemType, marshalType,
  								MARSHAL_ITEM_OF_ARRAY,
  								0,
  								newElemAddress);
***************
*** 1511,1523 ****
  		    fprintf(stderr, "Multidimential arrays are not supported for marshaling as a return value\n");
  		    return;
  	    }
- 
      }
!     // Should not reach here but, make the compiler happy.
      return;
  }
  
! static void MarshalByRefStruct(jit_function_t function, ILJitValue inAddress, ILType *structureILType, ILJitValue outAddress, jit_nint offset, unsigned int addressKind)
  {
      ILClass *classInfo = ILClassResolve(ILType_ToValueType(structureILType));
      ILField *field = 0;
--- 1790,1802 ----
  		    fprintf(stderr, "Multidimential arrays are not supported for marshaling as a return value\n");
  		    return;
  	    }
      }
!     // If we handle about all the cases above then we should not reach here,
!     // however we make the compiler happy.
      return;
  }
  
! static void MarshalByRefStruct(jit_function_t function, ILJitValue inAddress, ILType *structureILType, ILUInt32 marshalType, ILJitValue outAddress, jit_nint offset, unsigned int addressKind)
  {
      ILClass *classInfo = ILClassResolve(ILType_ToValueType(structureILType));
      ILField *field = 0;
***************
*** 1529,1551 ****
  	    if(!ILField_IsStatic(field))
  	    {
  		    type = ILTypeGetEnumType(ILField_Type(field));
! 		    MarshalByRefValue(function, inAddress, type, 1, MARSHAL_ITEM_OF_STRUCTURE, field->offset + offset, outAddress);
  	    }
      }
      return;
  }
  
  
  
! void *ILJitDelegateGetClosure(ILExecThread *currentThread, ILObject *del, ILType *delType)
  {
- 	ILType *invokeSignature = ILMethod_Signature(((System_Delegate*)del)->methodInfo);
- 	int paramCount = ILTypeNumParams(invokeSignature);
- 	ILType *returnILType = ILTypeGetReturn(invokeSignature);
- 	ILJitType returnType = _ILJitGetReturnType(returnILType, ILExecThreadGetProcess(currentThread));
- 	ILJitType jitParamTypes[paramCount];
- 	ILJitType jitInvokeTypes[paramCount + 2];
- 	ILJitValue jitParams[paramCount + 2];
  	int current;
  	ILJitType newSignature;
  	ILType *valueType;	
--- 1808,1928 ----
  	    if(!ILField_IsStatic(field))
  	    {
  		    type = ILTypeGetEnumType(ILField_Type(field));
! 		    MarshalByRefValue(function, inAddress, type, marshalType, MARSHAL_ITEM_OF_STRUCTURE,
! 					field->offset + offset, outAddress);
  	    }
      }
      return;
  }
+ #endif // USE_BYREF_MARSHALING
+ 
+ /*
+  * Emit the code to call a delegate.
+  * args contains only the arguments passed to the method (excluding the this pointer).
+  */
+ static ILJitValue __ILJitDelegateInvokeCodeGen(ILJitFunction func,
+ 											  ILJitFunction invokeFunc,
+ 											  ILJitValue delegate,
+ 											  ILJitValue *args,
+ 											  ILUInt32 argCount)
+ {
+ 	ILJitType signature = jit_function_get_signature(invokeFunc);
+ 	ILUInt32 numArgs = jit_type_num_params(signature);
+ 	ILJitType returnType = jit_type_get_return(signature);
+ 	jit_label_t noTarget = jit_label_undefined;
+ 	jit_label_t endLabel = jit_label_undefined;
+ 	ILJitValue returnValue = 0;
+ 	ILJitValue temp;
+ 	ILJitValue target = jit_insn_load_relative(func, delegate,
+ 											   offsetof(System_Delegate, target),
+ 											   _IL_JIT_TYPE_VPTR);
+ 	ILJitValue function = jit_insn_load_relative(func, delegate,
+ 												 offsetof(System_Delegate, methodInfo),
+ 												 _IL_JIT_TYPE_VPTR);
+ 	ILJitType types[numArgs];
+ 	ILJitValue invokeArgs[numArgs];
+ 	ILUInt32 current;
+ 
+ #ifdef IL_JIT_THREAD_IN_SIGNATURE
+ 	if(argCount != numArgs - 2)
+ #else
+ 	if(argCount != numArgs - 1)
+ #endif
+ 	{
+ 		/* Something is wrong here. */
+ 	}
  
+ 	if(returnType != _IL_JIT_TYPE_VOID)
+ 	{
+ 		returnValue = jit_value_create(func, returnType);
+ 	}
+ #ifdef IL_JIT_FNPTR_ILMETHOD
+ 	/* We need to convert the methodInfo pointer to the vtable pointer first. */
+ 	function = jit_insn_call_native(func,
+ 									"ILRuntimeMethodToVtablePointer",
+ 									ILRuntimeMethodToVtablePointer,
+ 									_ILJitSignature_ILRuntimeMethodToVtablePointer,
+ 									&function, 1, 0);
+ #endif
  
+ 	jit_insn_branch_if_not(func, target, &noTarget);
+ #ifdef IL_JIT_THREAD_IN_SIGNATURE
+ 	invokeArgs[0] = _ILJitFunctionGetThread(func);
+ 	invokeArgs[1] = target;
+ #else
+ 	invokeArgs[0] = target;
+ #endif
+ 	for(current = 0; current < argCount; ++current)
+ 	{
+ 	#ifdef IL_JIT_THREAD_IN_SIGNATURE
+ 		invokeArgs[current + 2] = args[current];
+ 	#else
+ 		invokeArgs[current + 1] = args[current];
+ 	#endif
+ 	}
+ 	temp = jit_insn_call_indirect_vtable(func,
+ 										 function, signature,
+ 										 invokeArgs, numArgs, 0);
+ 	if(returnType != _IL_JIT_TYPE_VOID)
+ 	{
+ 		jit_insn_store(func, returnValue, temp);
+ 	}
+ 	jit_insn_branch(func, &endLabel);
+ 	jit_insn_label(func, &noTarget);
+ #ifdef IL_JIT_THREAD_IN_SIGNATURE
+ 	types[0] = jit_type_get_param(signature, 0);
+ 	invokeArgs[0] = _ILJitFunctionGetThread(func);
+ #endif
+ 	for(current = 0; current < argCount; ++current)
+ 	{
+ 	#ifdef IL_JIT_THREAD_IN_SIGNATURE
+ 		types[current + 1] = jit_type_get_param(signature, current + 2);
+ 		invokeArgs[current + 1] = args[current];
+ 	#else
+ 		types[current] = jit_type_get_param(signature, current + 1);
+ 		invokeArgs[current] = args[current];
+ 	#endif
+ 	}
+ 	if(!(signature = jit_type_create_signature(IL_JIT_CALLCONV_DEFAULT,
+ 											   returnType,
+ 											   types, numArgs - 1, 1)))
+ 	{
+ 		return 0;
+ 	}
+ 	temp = jit_insn_call_indirect_vtable(func,
+ 										 function, signature,
+ 										 invokeArgs, numArgs - 1, 0);
+ 	jit_type_free(signature);
+ 	if(returnType != _IL_JIT_TYPE_VOID)
+ 	{
+ 		jit_insn_store(func, returnValue, temp);
+ 	}
+ 	jit_insn_label(func, &endLabel);
+ 	return returnValue;
+ }
  
! void *ILJitDelegateGetClosure(ILObject *del, ILType *delType)
  {
  	int current;
  	ILJitType newSignature;
  	ILType *valueType;	
***************
*** 1557,1625 ****
  	ILJITCoder *jitCoder;
  	ILJitFunction delFunction;
  	ILJitValue returnValue = 0;
- 	ILJitValue tempParams[paramCount + 2];
- 	unsigned int typeFlag;
  	ILType *type;
! 	ILJitValue newValue;
      	for(current = 0; current < paramCount; ++current)
  	{
  		valueType = ILTypeGetParam(invokeSignature, current + 1);
! 		jitParamTypes[current] = _ILJitGetArgType(valueType, ILExecThreadGetProcess(currentThread));
  		jitInvokeTypes[current + 2] = jitParamTypes[current];
  	}
  	newSignature = jit_type_create_signature(jit_abi_cdecl,
  						    returnType,
  						    jitParamTypes,
  						    paramCount, 1);
  	jitInvokeTypes[0] = jit_type_void_ptr;
  	jitInvokeTypes[1] = jit_type_void_ptr;
  	delInvokeSignature = jit_type_create_signature(jit_abi_cdecl,
  							returnType,
  							jitInvokeTypes,
  							paramCount + 2, 1);
! 	method = ILTypeGetDelegateMethod(delType);
  	info = ILMethod_Owner(method);
  	classPrivate = (ILClassPrivate *)info->userData;
  	jitCoder = (ILJITCoder *)(classPrivate->process->coder);
  
  	function = jit_function_create(jitCoder->context, newSignature);
- 	delFunction = ILJitFunctionFromILMethod(method);
  
  	jit_function_set_meta(function, IL_JIT_META_METHOD, method, 0, 0);
  
  	for(current = 0; current < paramCount; ++current)
  	{
  		tempParams[current] = jit_value_get_param(function, current);
! 		jitParams[current + 2] = (ILJitValue)MarshalDelegateValue(function, jit_value_get_param(function, current), ILTypeGetParam(invokeSignature, current + 1), current + 1, 0, 0, 0, currentThread);
  	}
- 
- 	jitParams[0] = jit_value_create_nint_constant(function, jit_type_void_ptr, (jit_nint)currentThread);
- 	jitParams[1] = jit_value_create_nint_constant(function, jit_type_void_ptr, (jit_nint)del);
- 	if(returnType==jit_type_void) jit_insn_call(function, "callDelegatePinvokeMethod", delFunction, delInvokeSignature, jitParams, paramCount + 2, JIT_CALL_NOTHROW);
  	else
  	{
! 		returnValue = jit_insn_call(function, "callDelegatePinvokeMethod", delFunction, delInvokeSignature, jitParams, paramCount + 2, JIT_CALL_NOTHROW);
! 		returnValue = (ILJitValue)MarshalDelegateReturnValue(function, returnValue, returnILType, 0, 0, 0, currentThread);
  	}
  	for(current = 0; current < paramCount; ++current)
  	{
  		newValue = jitParams[current + 2];
  		type = ILTypeGetParam(invokeSignature, current + 1);
  		type = ILTypeGetEnumType(type);
! 
! 		if(type!=0 && ILType_IsSimpleArray(type))
! 		{
! 			MarshalDelegateByRefValue(function, newValue, type, current + 1, 0, 0, tempParams[current], currentThread);
! 		}
! 		else if(type!=0 && ILType_IsComplex(type))
! 		{
! 			typeFlag = ILType_Kind(type);
! 			if(typeFlag==IL_TYPE_COMPLEX_BYREF || typeFlag==IL_TYPE_COMPLEX_PTR)
  			{
! 				MarshalDelegateByRefValue(function, newValue, type, current + 1, 0, 0, tempParams[current], currentThread);
  			}
  		}
  	}
  	if(returnType==jit_type_void)jit_insn_return(function, 0);
  	else jit_insn_return(function, returnValue);
  	jit_function_compile(function);
--- 1934,2152 ----
  	ILJITCoder *jitCoder;
  	ILJitFunction delFunction;
  	ILJitValue returnValue = 0;
  	ILType *type;
! 	method = ILTypeGetDelegateMethod(delType);
! 	if(!method)
! 	{
! 		method = ((System_Delegate*)del)->methodInfo;
! 	}
! 	ILType *invokeSignature = ILMethod_Signature(method);
! 	int paramCount = ILTypeNumParams(invokeSignature);
! 	ILType *returnILType = ILTypeGetReturn(invokeSignature);
! 	ILJitType returnType = _ILJitGetReturnType(returnILType, ILExecThreadGetProcess(ILExecThreadCurrent()));
! 	ILJitType jitParamTypes[paramCount];
! 	ILJitType jitInvokeTypes[paramCount + 2];
! 	ILJitValue jitParams[paramCount + 2];
! 	ILJitValue tempParams[paramCount + 2];
! 	ILUInt32 marshalType;
! 	char *customName;
! 	int customNameLen;
! 	char *customCookie;
! 	int customCookieLen;
! 
      	for(current = 0; current < paramCount; ++current)
  	{
  		valueType = ILTypeGetParam(invokeSignature, current + 1);
! 		jitParamTypes[current] = _ILJitGetArgType(valueType, ILExecThreadGetProcess(ILExecThreadCurrent()));
! #ifdef IL_JIT_THREAD_IN_SIGNATURE
  		jitInvokeTypes[current + 2] = jitParamTypes[current];
+ #else
+ 		jitInvokeTypes[current + 1] = jitParamTypes[current];
+ #endif
  	}
  	newSignature = jit_type_create_signature(jit_abi_cdecl,
  						    returnType,
  						    jitParamTypes,
  						    paramCount, 1);
  	jitInvokeTypes[0] = jit_type_void_ptr;
+ #ifdef IL_JIT_THREAD_IN_SIGNATURE
  	jitInvokeTypes[1] = jit_type_void_ptr;
+ #endif
  	delInvokeSignature = jit_type_create_signature(jit_abi_cdecl,
  							returnType,
  							jitInvokeTypes,
+ #ifdef IL_JIT_THREAD_IN_SIGNATURE
  							paramCount + 2, 1);
! #else
! 							paramCount + 1, 1);
! #endif
  	info = ILMethod_Owner(method);
  	classPrivate = (ILClassPrivate *)info->userData;
  	jitCoder = (ILJITCoder *)(classPrivate->process->coder);
  
  	function = jit_function_create(jitCoder->context, newSignature);
  
  	jit_function_set_meta(function, IL_JIT_META_METHOD, method, 0, 0);
  
  	for(current = 0; current < paramCount; ++current)
  	{
  		tempParams[current] = jit_value_get_param(function, current);
! 		type = ILTypeGetParam(invokeSignature, current + 1);
! 		marshalType = ILPInvokeGetMarshalType(0, method, current + 1, &customName, &customNameLen,
! 									      &customCookie, &customCookieLen,
! 									      type);
! #ifdef IL_JIT_THREAD_IN_SIGNATURE
! 		jitParams[current + 2] = jit_value_get_param(function, current);
! #else
! 		jitParams[current + 1] = jit_value_get_param(function, current);
! #endif
! 		if(marshalType==IL_META_MARSHAL_CUSTOM)
! 		{
! 			ILJitValue params[4];
! 			params[0] = jit_value_get_param(function, current);
! 			params[1] = jit_value_create_nint_constant(function, _IL_JIT_TYPE_VPTR, (jit_nint)type);
! 			params[2] = jit_value_create_nint_constant(function, _IL_JIT_TYPE_VPTR, (jit_nint)method);
! 			params[3] = _ILJitFunctionGetThread(function);
! 			returnValue = jit_insn_call_native(function, "MarshalCustomToObject", MarshalCustomToObject,
! 							    _ILJitSignature_MarshalCustomToObject, params, 4, JIT_CALL_NOTHROW);
! 		}
! #ifdef IL_JIT_THREAD_IN_SIGNATURE
! 		else if((!jitParams[current + 2] || marshalType != IL_META_MARSHAL_DIRECT) && NeedMarshalValue(type))
! #else
! 		else if((!jitParams[current + 1] || marshalType != IL_META_MARSHAL_DIRECT) && NeedMarshalValue(type))
! #endif
! 		{
! #ifdef IL_JIT_THREAD_IN_SIGNATURE
! 			jitParams[current + 2] =
! #else
! 			jitParams[current + 1] =
! #endif
! 						    (ILJitValue)MarshalDelegateValue(function, jit_value_get_param(function, current), type,
! 										    marshalType, MARSHAL_FIRST_LEVEL_VALUE, 0, 0);
! 		}
! 	}
! 	marshalType = ILPInvokeGetMarshalType
! 			(0, method, 0, &customName, &customNameLen,
! 			 &customCookie, &customCookieLen, returnILType);
! 	if(!ILTypeIsDelegate(delType))
!         {
! 		delFunction = jit_function_create(jitCoder->context, delInvokeSignature);	
! 		returnValue = __ILJitDelegateInvokeCodeGen(function, delFunction,
! 									jit_value_create_nint_constant(function, _IL_JIT_TYPE_VPTR, (jit_nint)del),
! #ifdef IL_JIT_THREAD_IN_SIGNATURE
! 									&jitParams[2], paramCount);
! #else
! 									&jitParams[1], paramCount);
! #endif
! 		if(returnType!=jit_type_void)
! 		{
! 			if(marshalType==IL_META_MARSHAL_CUSTOM)
! 			{
! 				ILJitValue params[4];
! 				params[0] = returnValue;
! 				params[1] = jit_value_create_nint_constant(function, _IL_JIT_TYPE_VPTR, (jit_nint)returnILType);
! 				params[2] = jit_value_create_nint_constant(function, _IL_JIT_TYPE_VPTR, (jit_nint)method);
! 				params[3] = _ILJitFunctionGetThread(function);
! 				returnValue = jit_insn_call_native(function, "MarshalObjectToCustom",
! 										MarshalObjectToCustom,
! 										_ILJitSignature_MarshalObjectToCustom,
! 										params, 4, JIT_CALL_NOTHROW);
! 			}
! 			else if((!ILTypeIsStringClass(returnILType) || marshalType!=IL_META_MARSHAL_DIRECT)
! 					&& NeedMarshalValue(returnILType))
! 			{
! 				returnValue = (ILJitValue)MarshalDelegateReturnValue(function, returnValue,
! 											returnILType, marshalType,
! 											MARSHAL_FIRST_LEVEL_VALUE, 0,
! 											0);
! 			}
! 		}
  	}
  	else
  	{
! 		delFunction = ILJitFunctionFromILMethod(method);
! #ifdef IL_JIT_THREAD_SIGNATURE
! 		jitParams[0] = _ILJitFunctionGetThread(function);
! 		jitParams[1] = jit_value_create_nint_constant(function, jit_type_void_ptr, (jit_nint)del);
! #else
! 		jitParams[0] = jit_value_create_nint_constant(function, jit_type_void_ptr, (jit_nint)del);
! #endif
! 		if(returnType==jit_type_void) jit_insn_call(function, "callDelegatePinvokeMethod",
! 							    delFunction, delInvokeSignature,
! #ifdef IL_JIT_THREAD_SIGNATURE
! 							    jitParams, paramCount + 2,
! #else
! 							    jitParams, paramCount + 1,
! #endif
! 							    JIT_CALL_NOTHROW);
! 		else
! 		{
! 			returnValue = jit_insn_call(function, "callDelegatePinvokeMethod",
! 						    delFunction, delInvokeSignature,
! #ifdef IL_JIT_THREAD_SIGNATURE
! 						    jitParams, paramCount + 2,
! #else
! 						    jitParams, paramCount + 1,
! #endif
! 						    JIT_CALL_NOTHROW);
! 			if(marshalType==IL_META_MARSHAL_CUSTOM)
! 			{
! 				ILJitValue params[4];
! 				params[0] = returnValue;
! 				params[1] = jit_value_create_nint_constant(function, _IL_JIT_TYPE_VPTR, (jit_nint)returnILType);
! 				params[2] = jit_value_create_nint_constant(function, _IL_JIT_TYPE_VPTR, (jit_nint)method);
! 				params[3] = _ILJitFunctionGetThread(function);
! 				returnValue = jit_insn_call_native(function, "MarshalObjectToCustom", MarshalObjectToCustom,
! 									    _ILJitSignature_MarshalObjectToCustom, params, 4, JIT_CALL_NOTHROW);
! 			}
! 			else if((!ILTypeIsStringClass(returnILType) || marshalType!=IL_META_MARSHAL_DIRECT)
! 				    && NeedMarshalValue(returnILType))
! 			{
! 				returnValue = (ILJitValue)MarshalDelegateReturnValue(function, returnValue,
! 											returnILType, marshalType,
! 											MARSHAL_FIRST_LEVEL_VALUE, 0,
! 											0);
! 			}
! 		}	
  	}
+ 
+ #ifdef USE_BYREF_MARSHALING
  	for(current = 0; current < paramCount; ++current)
  	{
+ #ifdef IL_JIT_THREAD_IN_SIGNATURE
  		newValue = jitParams[current + 2];
+ #else
+ 		newValue = jitParams[current + 1];
+ #endif
  		type = ILTypeGetParam(invokeSignature, current + 1);
  		type = ILTypeGetEnumType(type);
! 		marshalType = ILPInvokeGetMarshalType
! 					(0, method, current, &customName, &customNameLen,
! 							&customCookie, &customCookieLen, type);
! 		if((ILTypeIsStringClass(type) || type!=IL_META_MARSHAL_DIRECT)
! 			&& NeedMarshalValue(type) && marshalType!=IL_META_MARSHAL_CUSTOM && type!=0)
! 		{
! 			if(ILType_IsSimpleArray(type))
! 			{
! 				// Does anyone use this?
! 				MarshalDelegateByRefValue(function, newValue, type, marshalType,
! 				 				    MARSHAL_FIRST_LEVEL_VALUE, 0,
! 			 					    tempParams[current]);
! 			}
! 			else if(ILType_IsComplex(type))
  			{
! 				typeFlag = ILType_Kind(type);
! 				if(typeFlag==IL_TYPE_COMPLEX_BYREF || typeFlag==IL_TYPE_COMPLEX_PTR)
! 				{
! 					// Does anyone use this?
! 					MarshalDelegateByRefValue(function, newValue, type, marshalType, 
! 									    MARSHAL_FIRST_LEVEL_VALUE, 0, 
! 									    tempParams[current]);
! 				}
  			}
  		}
  	}
+ #endif
  	if(returnType==jit_type_void)jit_insn_return(function, 0);
  	else jit_insn_return(function, returnValue);
  	jit_function_compile(function);
***************
*** 1627,1634 ****
  	return ((System_Delegate*)del)->closure;
  }
  
! 
! static ILJitValue MarshalDelegateValue(jit_function_t function, ILJitValue in, ILType *type, ILUInt32 current, unsigned int addressKind, jit_nint offset, ILJitValue outAddress, ILExecThread *thread)
  {
      ILJitValue retValue;
      ILJitValue outAddressValue = outAddress;
--- 2154,2160 ----
  	return ((System_Delegate*)del)->closure;
  }
  
! static ILJitValue MarshalDelegateValue(jit_function_t function, ILJitValue in, ILType *type, ILUInt32 marshalType, unsigned int addressKind, jit_nint offset, ILJitValue outAddress)
  {
      ILJitValue retValue;
      ILJitValue outAddressValue = outAddress;
***************
*** 1638,1669 ****
      ILJitValue srcElemSize;
      ILType *elemType;
      ILJitValue newElemSize, newArraySize;
!     ILJitValue newArray;
      jit_label_t startLoop = jit_label_undefined;
      jit_label_t endLoop = jit_label_undefined;
      ILJitValue srcElemAddress;
      ILJitValue newElemAddress;
      ILJitValue counter;
!     ILJitValue arraySize;    
!     ILUInt32 marshalType;
!     char *customName;
!     int customNameLen;
!     char *customCookie;
!     int customCookieLen;
!     ILMethod *method = (ILMethod *)jit_function_get_meta(function, IL_JIT_META_METHOD);
!     ILPInvoke *pinv = ILPInvokeFind(method);
!     marshalType = ILPInvokeGetMarshalType(pinv, method, current, &customName, &customNameLen,
! 							&customCookie,	&customCookieLen, type);
!     if(marshalType == IL_META_MARSHAL_DIRECT && addressKind==MARSHAL_FIRST_LEVEL_VALUE)
!     {
! 	    return in;
!     }
!     else if(marshalType == IL_META_MARSHAL_CUSTOM)
      {
  	    fprintf(stderr, "Custom marshaling not supported in delegate value\n");
  	    return 0;
      }
-     type = ILTypeGetEnumType(type);
  
      switch(addressKind)
      {    
--- 2164,2183 ----
      ILJitValue srcElemSize;
      ILType *elemType;
      ILJitValue newElemSize, newArraySize;
!     ILJitValue newArray = jit_value_create(function, _IL_JIT_TYPE_VPTR);
      jit_label_t startLoop = jit_label_undefined;
      jit_label_t endLoop = jit_label_undefined;
      ILJitValue srcElemAddress;
      ILJitValue newElemAddress;
      ILJitValue counter;
!     ILJitValue arraySize;
!     type = ILTypeGetEnumType(type);
! 
!     if(marshalType == IL_META_MARSHAL_CUSTOM)
      {
  	    fprintf(stderr, "Custom marshaling not supported in delegate value\n");
  	    return 0;
      }
  
      switch(addressKind)
      {    
***************
*** 1681,1687 ****
  	    }
  	    break;
      }
- 
      if(ILType_IsPrimitive(type))
      {
  	switch(ILType_ToElement(type))
--- 2195,2200 ----
